#!/usr/bin/perl
# 
# library - ping 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.06;
	# 
	# ver 0.00 [2004/04/18] 
	# ver 0.01 [2004/05/26] ȥåХå󥰥륯ȤλȲ褦
	# ver 0.02 [2004/06/02]  sbcms.pl ƤӽФ褦
	# ver 0.03 [2004/06/05] sbping_discover_trackback, sbping_search_pingurl, sbping_tb_myself ɲ
	# ver 0.04 [2004/07/19] ping ν㴳ѹ
	# ver 0.05 [2004/07/27] sbping_update ѹ
	# ver 0.06 [2004/07/29] ping Υ顼åѹ
	require HTTP::Request;
	require 'sbtext.pl';
	require 'sbcms.pl';
}
sub sbping_update { #  ping 
	my $list = shift;
	my $stat = '';
	$list = &sbtxt_det($list);
	$list = &sbtxt_lfconv($list,1);
	return($stat) if ($list eq '');
	my $content = '';
	{ # ǡ
		my $blog = ($gEng{'code'} ne 'utf8') ? &sblang_conv($gEnv{'conf'}{'blog_title'},'utf8',$gEnv{'code'}) : $gEnv{'conf'}{'blog_title'};
		$content .= '<?xml version="1.0"?>' . "\n";
		$content .= '<methodCall>' . "\n";
		$content .= '<methodName>weblogUpdates.ping</methodName>' . "\n";
		$content .= '<params>' . "\n";
		$content .= '<param><value>' . $blog . '</value></param>';
		$content .= '<param><value>' . $gEnv{srv}{base} . '</value></param>';
		$content .= '</params>' . "\n";
		$content .= '</methodCall>' . "\n";
	}
	my $ua = &sbini_agent();
	my @ping_list = split("\n",$list);
	foreach my $url ( @ping_list ) {
		$url =~ s/^\s*//;
		$url =~ s/\s*$//;
		my $request = '';
		$request = HTTP::Request->new(POST => $url);
		$request->content_type('text/xml');
		$request->content($content);
		my $response = $ua->request($request);
		if ( index($response->code,'2') == 0 ) {
			if ($response->content =~ /error.*?<boolean>(\d+)/s) {
				my $check = $1;
				$stat .= &sbtxt_lfconv(&sbtxt_ent($url)) . '%n' if (!$check);
			}
		}
	}
	return($stat);
}
sub sbping_tb { # ȥåХå ping 
	my ($list,$eid) = @_;
	my $check_local = $gEnv{'srv'}{'cgi'} . $gEnv{'basic'}{'sb'};
	my $stat = '';
	$list = &sbtxt_lfconv(&sbtxt_det($list),1);
	return($stat) if ($list eq '');
	my $content = '';
	{ # ǡ
		my $aDescLen = 200;
		my $data = $gData{'entry'}{$eid}{'ent'};
		my $url  = &sbcms_permalink($eid,$$data{'date'});
		my $subj = ($gEng{'code'} ne 'utf8') ? &sblang_conv($$data{'subj'},'utf8',$gEnv{'code'}) : $$data{'subj'};
		my $blog = ($gEng{'code'} ne 'utf8') ? &sblang_conv($gEnv{'conf'}{'blog_title'},'utf8',$gEnv{'code'}) : $gEnv{'conf'}{'blog_title'};
		my $sum  = &sbcms_make_summary($$data{'sum'},$$data{'body'},$aDescLen);
		$sum = &sblang_conv($sum,'utf8',$gEnv{'code'}) if ($gEng{'code'} ne 'utf8');
		$sum  =~ s/\'/&#39;/g;
		$subj =~ s/\'/&#39;/g;
		$blog =~ s/\'/&#39;/g;
		$content .= 'title=' . &sbtxt_urienc($subj);
		$content .= '&url=' . &sbtxt_urienc($url);
		$content .= '&excerpt=' . &sbtxt_urienc($sum);
		$content .= '&blog_name=' . &sbtxt_urienc($blog);
		$content .= '&charset=utf8';
	}
	my $ua = &sbini_agent();
	my @tb_list = split("\n",$list);
	foreach my $url ( @tb_list ) {
		$url =~ s/^\s*//;
		$url =~ s/\s*$//;
		my $request = '';
		if ( index($url,'?') > -1 ) {
			$request = HTTP::Request->new(GET => $url . '&' . $content);
		} else {
			$request = HTTP::Request->new(POST => $url);
			$request->content_type('application/x-www-form-urlencoded');
			$request->content($content);
		}
		if ( index($url,$check_local) > -1 ) {
			if ( &sbping_tb_myself($url,$eid) ) {
				$stat .= &sbtxt_ent($url) . '%n' ;
			} else {
				$gIn{'entry_tbping'} .= "\n" if ($gIn{'entry_tbping'} ne '');
				$gIn{'entry_tbping'} .= $url;
			}
		} else {
			my $response = $ua->request($request);
			if ( index($response->code,'2') == 0 ) {
				my $data = $response->content;
				$stat .= &sbtxt_lfconv(&sbtxt_ent($url)) . '%n' if ($data =~ /<error>0<\/error>/s);
			} else {
				$gIn{'entry_tbping'} .= "\n" if ($gIn{'entry_tbping'} ne '');
				$gIn{'entry_tbping'} .= $url;
			}
		}
	}
	return($stat);
}
sub sbping_tb_myself {
	my ($url,$eid) = @_;
	my $aDescLen = 200;
	if ($url =~ /(\d+?)$/) {
		my $dest = $1;
		return(0) if ($eid eq $dest); # Ʊ쥨ȥ꡼ФȥåХåϽʤ
		&sbfile_read_datafile('tb');
		&sbfile_read_entry($dest);
		return(0) if ( $gData{'entry'}{$dest}{'ent'}{'atb'} == 0 );
		my $data = $gData{'entry'}{$eid}{'ent'};
		my $url  = &sbcms_permalink($eid,$$data{'date'});
		my $subj = $$data{'subj'};
		my $blog = $gEnv{'conf'}{'blog_title'};
		my $sum  = &sbcms_make_summary($$data{'sum'},$$data{'body'},$aDescLen);
		$sum  =~ s/\'/&#39;/g;
		$subj =~ s/\'/&#39;/g;
		$blog =~ s/\'/&#39;/g;
		my $num = @{$gData{'entry'}{$dest}{'tb'}};
		$gData{'entry'}{$dest}{'tb'}[$num]{'id'}   = $gData{'num'}{'tb'};
		$gData{'entry'}{$dest}{'tb'}[$num]{'wid'}  = 0;
		$gData{'entry'}{$dest}{'tb'}[$num]{'eid'}  = $dest;
		$gData{'entry'}{$dest}{'tb'}[$num]{'stat'} = ($gData{'entry'}{$dest}{'ent'}{'atb'} == 1) ? 1 : 0;
		$gData{'entry'}{$dest}{'tb'}[$num]{'date'} = $gNowTime;
		$gData{'entry'}{$dest}{'tb'}[$num]{'body'} = $sum;
		$gData{'entry'}{$dest}{'tb'}[$num]{'subj'} = $subj;
		$gData{'entry'}{$dest}{'tb'}[$num]{'name'} = $blog;
		$gData{'entry'}{$dest}{'tb'}[$num]{'url'}  = $url;
		$gData{'entry'}{$dest}{'tb'}[$num]{'host'} = $ENV{'REMOTE_ADDR'};
		&sbini_creat_newtb($dest,$gData{'entry'}{$dest}{'tb'}[$num]{'stat'},$gNowTime,$subj,$blog,$url);
		$gData{'entry'}{$dest}{'ent'}{'tb'} = &sbadmn_count_comtb($dest,'tb');
		$gData{'ent'}[$dest]{'tb'} = $gData{'entry'}{$dest}{'ent'}{'tb'};
		&sbfile_update_entry($dest);
		&sbfile_update_datafile('tb');
		&sbfile_update_datafile('ent');
		return(1);
	}
	return(0);
}
sub sbping_discover_trackback {
	my $text = shift;
	my $num = 0;
	$text = &sbtxt_lfconv(&sbtxt_det($text),1);
	$text =~ tr/\x0D\x0A//d;
	my @urls = $text =~ /s?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+/g;
	{ # ʣ URL κ
		my %cnt;
		@urls = grep(!$cnt{$_}++, @urls);
	}
	my $ua = &sbini_agent();
	foreach my $url (@urls) {
		my $response = $ua->get($url);
		if ( index(${$response}{'_rc'},'2') == 0 ) {
			my $ping_url = &sbping_search_pingurl(${$response}{'_content'}, $url);
			if ($ping_url ne '') {
				$num++;
				$gIn{'entry_tbping'} .= "\n" if ($gIn{'entry_tbping'} ne '');
				$gIn{'entry_tbping'} .= $ping_url;
			}
		}
	}
	return($num);
}
sub sbping_search_pingurl {
	my ($text,$url) = @_;
	my $found = '';
	my @rdfs = $text =~ /(<rdf:RDF.*?<\/rdf:RDF>)/smg;
	foreach my $rdf ( @rdfs ) {
		my ($identifier,$ping_url);
		$rdf =~ /dc:identifier=\"(.*?)\"/sm;
		$identifier = $1;
		$rdf =~ /trackback:ping=\"(.*?)\"/sm;
		$ping_url = $1;
		$found = $ping_url if ($identifier ne '' and $ping_url ne '' and $identifier eq $url);
		last if ($found ne '');
	}
	return($found);
}
1;
