#!/usr/bin/perl
# 
# sb - weblog management system
# == Module checker for sb ===========
# == created by Rumurin 2004.06.17 ===
# == modified by Takuya Otani ========

{ # 
	use strict;
	use vars qw($gVersion_ @gRequired @gOptional);
	use lib  qw(. ../ext ./ext);
}
{ # ᥤ롼
	&initialize();
	&mainscript();
}
exit(0);

sub initialize {
	$gVersion_ = '0.02';
	@gRequired = ('LWP::UserAgent','HTTP::Request','XML::Parser::Lite','Jcode',);
	@gOptional = ('Image::Magick');
	print 'Content-Type: text/html;charset=EUC-JP',"\n\n";
	print <<'_HTML_HEAD_';
<html>
<head>
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<style type="text/css">
		body { margin: 10px; padding: 0px; font-size: 12px; line-height: 135%; color: #333; background-color: #fff; }
		h1 { font-size: 110%; margin: 0px; border-bottom: 1px dashed #a0a0ff; color: darkred; }
		h2 { font-size: 100%; font-weight: bold; color: darkgreen; margin: 8px 0px 0px 0px; }
		.notinstalled { color: red; }
		.installed { color: green; }
	</style>
	<title>⥸塼å for sb</title>
</head>
<body>
<h1>⥸塼å for sb</h1>
_HTML_HEAD_
	return(1);
}
sub mainscript {
	print '<h2>ɬܥ⥸塼</h2>',"\n",'<ul>',"\n";
	foreach my $lib (@gRequired) {
		my $eval = 'use ' . $lib . ';';
		eval($eval);
		if ($@) {
			print '<li class="notinstalled">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
		} else {
			print '<li class="installed">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
		}
	}
	print '</ul>',"\n";
	print '<h2>ץ⥸塼</h2>',"\n",'<ul>',"\n";
	foreach my $lib (@gOptional) {
		my $eval = 'use ' . $lib . ';';
		eval($eval);
		if ($@) {
			print '<li class="notinstalled">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
		} else {
			print '<li class="installed">',$lib,'ϥ󥹥ȡ뤵Ƥޤ</li>',"\n";
		}
	}
	print '</ul>',"\n";
	print  <<'_HTML_FOOT_';
<h2>ɥХ</h2>
<ul>
	<li>ɬܥ⥸塼ǥ󥹥ȡ뤵ƤʤΤ<a href="http://serennz.cool.ne.jp/sblog/">sbȯ</a>곰⥸塼ɡ󥹥ȡ뤷Ƥ</li>
	<li>ץ⥸塼Image::Magick󥹥ȡ뤵Ƥʤ硢ͥԤޤ</li>
</ul>
</body>
</html>
_HTML_FOOT_
	return();
}
